global constant VAL = 1,
		VAR = 2
global constant OPCODES = {
{"mov",#0,{VAL,VAL}},
{"mov",#1,{VAL,VAR}},
{"movdi",#2,{VAL,VAL,VAL}},
{"movdi",#3,{VAL,VAR,VAL}},
{"movdi",#4,{VAL,VAL,VAR}},
{"movdi",#5,{VAL,VAR,VAR}},
{"movsi",#6,{VAL,VAL,VAL}},
{"movsi",#7,{VAL,VAR,VAL}},
{"movsi",#8,{VAL,VAL,VAR}},
{"movsi",#9,{VAL,VAR,VAR}},
{"add",#A,{VAL,VAL}},
{"add",#B,{VAL,VAR}},
{"sub",#C,{VAL,VAL}},
{"sub",#D,{VAL,VAR}},
{"mul",#E,{VAL,VAL}},
{"mul",#F,{VAL,VAR}},
{"div",#10,{VAL,VAL}},
{"div",#11,{VAL,VAR}},
{"and",#12,{VAL,VAL}},
{"and",#13,{VAL,VAR}},
{"or",#14,{VAL,VAL}},
{"or",#15,{VAL,VAR}},
{"xor",#16,{VAL,VAL}},
{"xor",#17,{VAL,VAR}},
{"not",#18,{VAL}},
{"andbits",#19,{VAL,VAL}},
{"andbits",#1A,{VAL,VAR}},
{"orbits",#1B,{VAL,VAL}},
{"orbits",#1C,{VAL,VAR}},
{"xorbits",#1D,{VAL,VAL}},
{"xorbits",#1E,{VAL,VAR}},
{"notbits",#1F,{VAL}},
{"movlen",#20,{VAL,VAL}},
{"movlen",#21,{VAL,VAR}},
{"repeat",#22,{VAL,VAL}},
{"repeat",#23,{VAL,VAR}},
{"append",#24,{VAL,VAL}},
{"append",#25,{VAL,VAR}},
{"prepend",#26,{VAL,VAL}},
{"prepend",#27,{VAL,VAR}},
{"concen",#28,{VAL,VAL}},
{"concen",#29,{VAL,VAR}},
{"isinteger",#2A,{VAL,VAL}},
{"isinteger",#2B,{VAR,VAL}},
{"isatom",#2C,{VAL,VAL}},
{"isatom",#2D,{VAR,VAL}},
{"issequence",#2E,{VAL,VAL}},
{"issequence",#2F,{VAR,VAL}},
{"floor",#30,{VAL}},
{"sqrt",#31,{VAL}},
{"remainder",#32,{VAL,VAL}},
{"remainder",#33,{VAL,VAR}},
{"rand",#34,{VAL,VAL}},
{"rand",#35,{VAL,VAR}},
{"sin",#36,{VAL}},
{"cos",#37,{VAL}},
{"tan",#38,{VAL}},
{"asin",#39,{VAL}},
{"acos",#3A,{VAL}},
{"atan",#3B,{VAL}},
{"log",#3C,{VAL}},
{"power",#3D,{VAL,VAL}},
{"power",#3E,{VAL,VAR}},
{"ce",#3F,{VAL,VAL,VAL}},
{"ce",#40,{VAR,VAL,VAL}},
{"ce",#41,{VAL,VAR,VAL}},
{"ce",#42,{VAR,VAR,VAL}},
{"cne",#43,{VAL,VAL,VAL}},
{"cne",#44,{VAR,VAL,VAL}},
{"cne",#45,{VAL,VAR,VAL}},
{"cne",#46,{VAR,VAR,VAL}},
{"cg",#47,{VAL,VAL,VAL}},
{"cg",#48,{VAR,VAL,VAL}},
{"cg",#49,{VAL,VAR,VAL}},
{"cg",#4A,{VAR,VAR,VAL}},
{"cl",#4B,{VAL,VAL,VAL}},
{"cl",#4C,{VAR,VAL,VAL}},
{"cl",#4D,{VAL,VAR,VAL}},
{"cl",#4E,{VAR,VAR,VAL}},
{"cge",#4F,{VAL,VAL,VAL}},
{"cge",#50,{VAR,VAL,VAL}},
{"cge",#51,{VAL,VAR,VAL}},
{"cge",#52,{VAR,VAR,VAL}},
{"cle",#53,{VAL,VAL,VAL}},
{"cle",#54,{VAR,VAL,VAL}},
{"cle",#55,{VAL,VAR,VAL}},
{"cle",#56,{VAR,VAR,VAL}},
{"se",#57,{VAL,VAL}},
{"se",#58,{VAR,VAL}},
{"se",#59,{VAL,VAR}},
{"se",#5A,{VAR,VAR}},
{"sne",#5B,{VAL,VAL}},
{"sne",#5C,{VAR,VAL}},
{"sne",#5D,{VAL,VAR}},
{"sne",#5E,{VAR,VAR}},
{"sg",#5F,{VAL,VAL}},
{"sg",#60,{VAR,VAL}},
{"sg",#61,{VAL,VAR}},
{"sg",#62,{VAR,VAR}},
{"sl",#63,{VAL,VAL}},
{"sl",#64,{VAR,VAL}},
{"sl",#65,{VAL,VAR}},
{"sl",#66,{VAR,VAR}},
{"sge",#67,{VAL,VAL}},
{"sge",#68,{VAR,VAL}},
{"sge",#69,{VAL,VAR}},
{"sge",#6A,{VAR,VAR}},
{"sle",#6B,{VAL,VAL}},
{"sle",#6C,{VAR,VAL}},
{"sle",#6D,{VAL,VAR}},
{"sle",#6E,{VAR,VAR}},
{"je",#6F,{VAL,VAL,VAL}},
{"je",#70,{VAR,VAL,VAL}},
{"je",#71,{VAL,VAR,VAL}},
{"je",#72,{VAR,VAR,VAL}},
{"je",#73,{VAL,VAL,VAR}},
{"je",#74,{VAR,VAL,VAR}},
{"je",#75,{VAL,VAR,VAR}},
{"je",#76,{VAR,VAR,VAR}},
{"jne",#77,{VAL,VAL,VAL}},
{"jne",#78,{VAR,VAL,VAL}},
{"jne",#79,{VAL,VAR,VAL}},
{"jne",#7A,{VAR,VAR,VAL}},
{"jne",#7B,{VAL,VAL,VAR}},
{"jne",#7C,{VAR,VAL,VAR}},
{"jne",#7D,{VAL,VAR,VAR}},
{"jne",#7E,{VAR,VAR,VAR}},
{"jg",#7F,{VAL,VAL,VAL}},
{"jg",#80,{VAR,VAL,VAL}},
{"jg",#81,{VAL,VAR,VAL}},
{"jg",#82,{VAR,VAR,VAL}},
{"jg",#83,{VAL,VAL,VAR}},
{"jg",#84,{VAR,VAL,VAR}},
{"jg",#85,{VAL,VAR,VAR}},
{"jg",#86,{VAR,VAR,VAR}},
{"jl",#87,{VAL,VAL,VAL}},
{"jl",#88,{VAR,VAL,VAL}},
{"jl",#89,{VAL,VAR,VAL}},
{"jl",#8A,{VAR,VAR,VAL}},
{"jl",#8B,{VAL,VAL,VAR}},
{"jl",#8C,{VAR,VAL,VAR}},
{"jl",#8D,{VAL,VAR,VAR}},
{"jl",#8E,{VAR,VAR,VAR}},
{"jge",#8F,{VAL,VAL,VAL}},
{"jge",#90,{VAR,VAL,VAL}},
{"jge",#91,{VAL,VAR,VAL}},
{"jge",#92,{VAR,VAR,VAL}},
{"jge",#93,{VAL,VAL,VAR}},
{"jge",#94,{VAR,VAL,VAR}},
{"jge",#95,{VAL,VAR,VAR}},
{"jge",#96,{VAR,VAR,VAR}},
{"jle",#97,{VAL,VAL,VAL}},
{"jle",#98,{VAR,VAL,VAL}},
{"jle",#99,{VAL,VAR,VAL}},
{"jle",#9A,{VAR,VAR,VAL}},
{"jle",#9B,{VAL,VAL,VAR}},
{"jle",#9C,{VAR,VAL,VAR}},
{"jle",#9D,{VAL,VAR,VAR}},
{"jle",#9E,{VAR,VAR,VAR}},
{"cmp",#9F,{VAL,VAL,VAL}},
{"cmp",#A0,{VAR,VAL,VAL}},
{"cmp",#A1,{VAL,VAR,VAL}},
{"cmp",#A2,{VAR,VAR,VAL}},
{"equ",#A3,{VAL,VAL,VAL}},
{"equ",#A4,{VAR,VAL,VAL}},
{"equ",#A5,{VAL,VAR,VAL}},
{"equ",#A6,{VAR,VAR,VAL}},
{"ret",#A7,{}},
{"call",#A8,{VAL}},
{"call",#A9,{VAR}},
{"jmp",#AA,{VAL}},
{"jmp",#AB,{VAR}},
{"loop",#AC,{VAL,VAL}},
{"loop",#AD,{VAR,VAL}},
{"loopn",#AE,{VAL,VAL}},
{"loopn",#AF,{VAR,VAL}},
{"loopn",#B0,{VAL,VAR}},
{"loopn",#B1,{VAR,VAR}},
{"end",#B2,{}},
{"err",#B3,{VAL}},
{"err",#B4,{VAR}},
{"push",#B5,{VAL}},
{"push",#B6,{VAR}},
{"pop",#B7,{VAL}},
{"ldss",#B8,{VAL}},
{"puts",#B9,{VAL}},
{"puts",#BA,{VAR}},
{"print",#BB,{VAL}},
{"print",#BC,{VAR}},
{"time",#BD,{VAL}}}
